%
%Gist feature extraction 
addpath(genpath('/scratch/Dai/Code/ensemble'));

dictoryPath = '/scratch/Dai/Data/Classification/flower102/'; 

imgFolders = dir(strcat(dictoryPath,'*'));
imgFolders = imgFolders(3:end);
labelNums = length(imgFolders);

for nFolders=1:1
%     if (length(imgFolders(nFolders).name)<=2) 
%         continue;
%     end
        
    imgPath = strcat(dictoryPath,imgFolders(nFolders).name,'/');
    imgSet = dir(fullfile(imgPath,'*.jpg'));
    imgNums = length(imgSet);

    % Parameters:
    orientationsPerScale = [8 8 4];
    numberBlocks = 1;
    imageSize = 256;  % image must be a square 
    % Precompute filter transfert functions (only need to do this one, unless image size is changes):
    % createGabor(orientationsPerScale, imageSize); % this shows the filters

    savePath = strcat(imgPath,'Gist');
    if ~exist(savePath,'dir')
         mkdir(savePath);
    end

    G = createGabor(orientationsPerScale, imageSize);

    for n=1:imgNums  
        imgName = strcat(imgPath,imgSet(n).name);
        img = imread(imgName);
        if size(img,3)>1
           img = rgb2gray(img); 
        end
        img = imresize(img,[256 256]);
        output = prefilt(double(img), 4);
        g1 = gistGabor(output, 1, G);
%         g2 = gistGabor(output, 2, G);
%         g = cat(1,g1,g2);
        g = normalize(g1)*length(g1);
        saveName = strcat(savePath,'/',imgSet(n).name(1:end-4),'.mat');
        save(saveName, 'g');
    end
[nFolders]
end